# 1. General help #
New to Transmission?
  * Try the help in Transmission's "Help" menu.
  * simplehelp.net has an introduction for [Transmission on Macs](https://www.simplehelp.net/2008/07/17/how-to-use-transmission-as-your-bittorrent-client-os-x/).
  * Jun Azua has an introduction for [Transmission GUI on Linux](https://www.junauza.com/2009/01/how-to-use-bittorrent-in-linux.html).
  * Running Transmission [without a GUI](./Headless-Usage.md)
  * Using Transmission [from a web browser](./Web-Interface.md)

Want to learn more?
  * Visit our [forums](https://forum.transmissionbt.com)
  * Visit our [IRC](https://en.wikipedia.org/wiki/IRC) channel: [#transmission on Libera.Chat](https://web.libera.chat/#transmission)
  * Follow us on [Twitter](https://twitter.com/transmissionbt)

Want to contribute?

Much of this documentation is out-of-date or could be improved. Pull requests are greatly appreciated!
# 2. FAQ #
* [Can I sequence the files I download?](./Can-I-sequence-the-files-I-download.md)
* [Why are my speeds so slow?](./Why-Are-My-Speeds-So-Slow.md)
* [Why is my port closed?](./Why-is-my-port-closed.md)
* Q: How can I prevent the fragmentation of my downloaded files? 

  A: Use the [configuration option](./Editing-Configuration-Files.md) "preallocation": 2
# 3. More documentation #
 * [Configuration files](./Configuration-Files.md)
 * [Editing configuration files](./Editing-Configuration-Files.md)
 * [Environment variables](Environment-Variables.md)
 * [Extending Transmission using scripts](./Scripts.md)
 * [Blocklists](./Blocklists.md)
 * [How to build Transmission](Building-Transmission.md)
 * [RPC protocol specification](rpc-spec.md)
 * [Transmission's Peer ID and User-Agent headers](Peer-ID-and-User-Agent.md)
 * [Peer status text explained](Peer-Status-Text.md)

# 3. Report a problem / request a feature #
  * [Check](https://github.com/transmission/transmission/issues) whether the problem has already been reported.
  * If you do not see a ticket matching your problem or feature, read [this post](https://forum.transmissionbt.com/viewtopic.php?f=1&t=3274) about what to write, then [add a new ticket](https://github.com/transmission/transmission/issues/new).
  * If you _do_ see an existing ticket, please add a comment there. The more users are interested in a ticket, the higher its priority.

# 4. For contributors #
Transmission is a volunteer project and welcomes help.
Please contact us if you are interested in supporting Transmission in any of the following ways:

  * Code contribution
  * Testing
  * [Language translations](Translating.md)
  * Bug and request management
  * Documentation and Wiki editing
  * [Donations](https://transmissionbt.com/donate/)
  * If you want to alert us of a security vulnerability, please email security@transmissionbt.com. Please note that general support questions belong on the forum, and will be ignored if sent to this email address.
